VERSION 5.00
Begin VB.Form frmVis4 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00404040&
   Caption         =   "rumint: Binary Rainfall"
   ClientHeight    =   7065
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7770
   Icon            =   "frmVis4.frx":0000
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   7065
   ScaleWidth      =   7770
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkASCII 
      Caption         =   "Printable ASCII"
      Height          =   375
      Left            =   5160
      Style           =   1  'Graphical
      TabIndex        =   8
      Top             =   6600
      Width           =   1335
   End
   Begin VB.CheckBox chkNOP 
      Caption         =   "NOP 0x90"
      Height          =   375
      Left            =   3600
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   6600
      Width           =   1335
   End
   Begin VB.ComboBox cmbVisMode 
      Height          =   315
      ItemData        =   "frmVis4.frx":030A
      Left            =   120
      List            =   "frmVis4.frx":030C
      Style           =   2  'Dropdown List
      TabIndex        =   6
      Top             =   6600
      Width           =   1455
   End
   Begin VB.PictureBox picGraphBack 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   6255
      Left            =   0
      ScaleHeight     =   417
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   177
      TabIndex        =   3
      Top             =   0
      Visible         =   0   'False
      Width           =   2655
   End
   Begin VB.OptionButton radScroll 
      BackColor       =   &H00404040&
      Caption         =   "Option1"
      Height          =   255
      Index           =   1
      Left            =   1800
      TabIndex        =   2
      Top             =   6720
      Width           =   255
   End
   Begin VB.OptionButton radScroll 
      BackColor       =   &H00404040&
      Caption         =   "Option1"
      Height          =   255
      Index           =   0
      Left            =   1800
      TabIndex        =   1
      Top             =   6360
      Value           =   -1  'True
      Width           =   255
   End
   Begin VB.PictureBox picGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   6255
      Left            =   0
      ScaleHeight     =   417
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   129
      TabIndex        =   0
      Top             =   0
      Width           =   1935
   End
   Begin VB.Label lblHighlight 
      BackStyle       =   0  'Transparent
      Caption         =   "Highlight"
      Height          =   255
      Left            =   3600
      TabIndex        =   9
      Top             =   6360
      Width           =   975
   End
   Begin VB.Label lblDynamicScroll 
      BackStyle       =   0  'Transparent
      Caption         =   "Dynamic Scroll"
      Height          =   255
      Left            =   2160
      TabIndex        =   5
      Top             =   6720
      Width           =   1095
   End
   Begin VB.Label lblStaticScroll 
      BackStyle       =   0  'Transparent
      Caption         =   "Static Scroll"
      Height          =   255
      Left            =   2160
      TabIndex        =   4
      Top             =   6360
      Width           =   975
   End
End
Attribute VB_Name = "frmVis4"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit
Dim scrollLocation As Long
Dim thumbScrollLocation As Long
Dim plotColor As ColorConstants



Private Sub incrementScroll(ByRef targetPicGraph As PictureBox, ByRef localScrollLocation As Long, ByVal scrollMax As Long, ByVal increment As Long)
  If localScrollLocation < scrollMax Then
    localScrollLocation = localScrollLocation + increment
  Else
    localScrollLocation = 0
  End If
  targetPicGraph.Line (0, localScrollLocation)-(targetPicGraph.ScaleWidth, localScrollLocation), targetPicGraph.BackColor
  
End Sub

'This subroutine places a tooltip based on the X coordinate
'of the mouse pointer.  Results are returned in decimal, hex and ASCII
Private Sub picGraph_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim byteOffset As Integer
  Dim bitOffset As Integer
  
  If cmbVisMode.ListIndex = 1 Then  '24 bits per pixel
    byteOffset = X * 3 'use the backslash for integer division
    picGraph.ToolTipText = "byte offset=" & byteOffset
  End If
  
  If cmbVisMode.ListIndex = 2 Then '8 bits per pixel
    byteOffset = X
    picGraph.ToolTipText = "byte offset=" & byteOffset
  End If
    
  If cmbVisMode.ListIndex = 3 Then '1 bits per pixel
    byteOffset = X \ 8 'use the backslash for integer division
    bitOffset = X Mod 8
    picGraph.ToolTipText = "offset byte=" & byteOffset & " bit=" & bitOffset
  End If
End Sub

'***************** Graphics *********************
Public Sub Plot(ByVal packetNumber As Long, ByRef packetTxt As Variant, ByVal packetLen As Long)
  Dim scaledLength As Long
  Dim plotMode As String
  
  
  plotMode = detectPlotMode
     
  If plotMode = "staticscroll" Then 'static scroll
    'begin case
      If cmbVisMode.ListIndex = 0 Then
        plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
        Call PlotLength(picGraph, packetLen, scrollLocation) 'packet Length
      End If
      If cmbVisMode.ListIndex = 1 Then Call Plot24(packetTxt, picGraph, packetLen, scrollLocation) '24:1
      If cmbVisMode.ListIndex = 2 Then Call Plot8(packetTxt, picGraph, packetLen, scrollLocation) '8:1
      If cmbVisMode.ListIndex = 3 Then
        plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
        Call Plot1(packetTxt, picGraph, packetLen, scrollLocation) '1:1
      End If
    'end case
    Call incrementScroll(picGraph, scrollLocation, picGraph.ScaleHeight, 1)
  Else 'dynamic scroll
    copyMain2Buff
    'begin case
      If cmbVisMode.ListIndex = 0 Then
        plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
        Call PlotLength(picGraphBack, packetLen, 1) 'packet length
      End If
      If cmbVisMode.ListIndex = 1 Then Call Plot24(packetTxt, picGraphBack, packetLen, 1) '24:1
      If cmbVisMode.ListIndex = 2 Then Call Plot8(packetTxt, picGraphBack, packetLen, 1) '8:1
      If cmbVisMode.ListIndex = 3 Then
        plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
        Call Plot1(packetTxt, picGraphBack, packetLen, 1) '1:1
      End If
    'end case
    copyBuff2Main
  End If
End Sub

Private Sub Plot1(ByRef packetTxt As Variant, ByRef targetPicGraph As PictureBox, ByVal localPacketLen As Long, Y As Long)
  Dim byteCounter As Long
  Dim bitCounter As Long
  Dim X As Long
  Dim bit As Long
  
  'Debug.Print targetPicGraph.scaleWidth
  'If X <= targetPicGraph.scaleWidth Then 'constrain to visual portion of screen
    For byteCounter = 0 To modLibrary.Min(localPacketLen - 1, targetPicGraph.ScaleWidth)
      For bitCounter = 7 To 0 Step -1
        bit = packetTxt(byteCounter) And (2 ^ bitCounter) 'bitwise operation, pull out bit
        'NOP
        If bit > 0 And chkNOP.value = 0 And chkASCII.value = 0 Then targetPicGraph.PSet (X, Y), plotColor
        If bit > 0 And chkNOP.value = 1 And packetTxt(byteCounter) = 144 Then targetPicGraph.PSet (X, Y), vbRed
        If bit > 0 And chkNOP.value = 1 And packetTxt(byteCounter) <> 144 Then targetPicGraph.PSet (X, Y), RGB(64, 64, 64)
        If bit = 0 And chkNOP.value = 1 And packetTxt(byteCounter) = 144 Then targetPicGraph.PSet (X, Y), RGB(128, 0, 0)
        'ascii
        If bit > 0 And chkASCII.value = 1 And packetTxt(byteCounter) >= 32 And packetTxt(byteCounter) <= 126 Then targetPicGraph.PSet (X, Y), vbBlue
        If bit > 0 And chkASCII.value = 1 And (packetTxt(byteCounter) < 32 Or packetTxt(byteCounter) > 126) Then targetPicGraph.PSet (X, Y), RGB(64, 64, 64)
        If bit = 0 And chkASCII.value = 1 And packetTxt(byteCounter) >= 32 And packetTxt(byteCounter) <= 126 Then targetPicGraph.PSet (X, Y), RGB(0, 0, 128)
        
        X = X + 1
      Next bitCounter
    Next byteCounter
  'End If
End Sub


Private Sub Plot8(ByRef packetTxt As Variant, ByRef targetPicGraph As PictureBox, ByVal localPacketLen As Long, Y As Long)
  Dim counter As Long
  
  For counter = 0 To modLibrary.Min(localPacketLen - 1, targetPicGraph.ScaleWidth - 1)
    If chkNOP.value = 1 And packetTxt(counter) = 144 Then '144=0x90 hex (NOP)
      targetPicGraph.PSet (counter, Y), vbRed
    Else 'ascii
      If chkASCII.value = 1 And packetTxt(counter) >= 32 And packetTxt(counter) <= 126 Then
        targetPicGraph.PSet (counter, Y), vbBlue
      Else 'subdue non ascii
        If chkASCII.value = 1 And (packetTxt(counter) < 32 Or packetTxt(counter) > 126) Then
          targetPicGraph.PSet (counter, Y), RGB(64, 64, 64)
        Else 'normal plot mode
          targetPicGraph.PSet (counter, Y), RGB(0, packetTxt(counter), 0)
        End If
      End If
    End If
  Next counter
End Sub

Private Sub Plot24(ByRef packetTxt As Variant, ByRef targetPicGraph As PictureBox, ByVal localPacketLen As Long, Y As Long)
  Dim counter As Long
  Dim X As Long
  For counter = 0 To localPacketLen - 1 Step 3
    'Debug.Print counter & "  " & localPacketLen - 1
    If (counter + 2 <= localPacketLen - 1) Then targetPicGraph.PSet (X, Y), _
      RGB(packetTxt(counter), packetTxt(counter + 1), packetTxt(counter + 2)) 'this will sometime truncate last two bytes
    X = X + 1
  Next counter
End Sub


Private Sub PlotLength(ByRef targetPicGraph As PictureBox, ByVal localPacketLen As Long, Y As Long)
  Dim scaledLength As Long
  scaledLength = scaleRange(localPacketLen, picGraph.ScaleWidth)
  targetPicGraph.Line (0, Y)-(scaledLength, Y), plotColor
End Sub

Private Function detectPlotMode() As String
  If radScroll(0).value = True Then detectPlotMode = "staticscroll"
  If radScroll(1).value = True Then detectPlotMode = "dynamicscroll"
End Function

Private Sub copyBuff2Main()
  'copy buffer to main image
  picGraph.Cls
  BitBlt picGraph.hDC, 0, 0, picGraphBack.ScaleWidth, _
  picGraphBack.ScaleHeight, picGraphBack.hDC, 0, 0, vbSrcCopy
  
End Sub

Private Sub copyMain2Buff()
   'copy main image to buffer
    picGraphBack.Cls
    BitBlt picGraphBack.hDC, 0, 1, picGraph.ScaleWidth, _
       picGraph.ScaleHeight - 1, picGraph.hDC, 0, 0, vbSrcCopy
    
End Sub

Public Sub plotThumbnail(ByRef packetTxt As Variant, ByVal localPacketLen As Long)
  Dim counter As Long
      
  For counter = 0 To Min(localPacketLen - 1, frmMain.picVis(4).ScaleWidth - 1)
    frmMain.picVis(4).PSet (counter, thumbScrollLocation), RGB(0, packetTxt(counter), 0)
  Next counter
  
  If thumbScrollLocation < frmMain.picVis(4).ScaleHeight Then thumbScrollLocation = thumbScrollLocation + 1 Else thumbScrollLocation = 0
    
  'draw the scrolling position line, also serves to erase previous content
  frmMain.picVis(4).Line (0, thumbScrollLocation)-(frmMain.picVis(4).ScaleWidth, thumbScrollLocation), frmMain.picVis(4).BackColor
End Sub

'***************** Processing *******************
'This function is used to scale packet values as a fraction of the maximum packet size per RFC (1518 bytes)
Public Function scaleRange(ByVal actualValue As Long, ByVal maxRange As Long) As Long
  If maxRange <= 0 Then
    scaleRange = 0 'returns a zero to avoid division by zero
  Else
    scaleRange = (actualValue / 1518) * maxRange
  End If
End Function



Private Sub Form_Resize()
  Dim meHeight As Long
  meHeight = Me.Height
  
  If Me.Height < 3000 Then Me.Height = 3000
  If Me.Width < 2000 Then Me.Width = 2000
  
  picGraph.Cls
  picGraph.Left = 0
  picGraph.Top = 0
  picGraph.Height = Me.Height - 1100
  picGraph.Width = Me.Width
  
  picGraphBack.Cls
  picGraphBack.Top = 0
  picGraphBack.Left = 0
  picGraphBack.Height = Me.Height - 1100
  picGraphBack.Width = Me.Width
  
  radScroll(0).Top = picGraph.Height + 50
  radScroll(1).Top = picGraph.Height + 300
  lblStaticScroll.Top = picGraph.Height + 50
  lblDynamicScroll.Top = picGraph.Height + 300
  cmbVisMode.Top = picGraph.Height + 150
  scrollLocation = 0
  
  lblHighlight.Top = picGraph.Height + 30
  chkASCII.Top = picGraph.Height + 280
  chkNOP.Top = picGraph.Height + 280
  
  
End Sub

'Double clicking picture box zooms
'when bottom zoom is reached return to top level of zoom
Private Sub picGraph_DblClick()
  If cmbVisMode.ListIndex < (cmbVisMode.ListCount - 1) Then cmbVisMode.ListIndex = cmbVisMode.ListIndex + 1 Else cmbVisMode.ListIndex = 0
  initVisAll
End Sub



'***************** Interface ********************
Private Sub radScroll_Click(Index As Integer)
  initVisAll
End Sub

Private Sub cmbVisMode_Click()
  initVisAll
End Sub

Public Sub initVisAll()
  initVis        'initialize the main visualization
  initVisThumb   'initialize the thumbnail visualization on the toolbar
End Sub

'initialize the main visualization
Public Sub initVis()
  scrollLocation = 0 'reset current vertical location
  picGraph.Cls       'clear the graphics window
  picGraphBack.Cls   'clear the graphics buffer
End Sub

'initialize the thumnail visualization
Public Sub initVisThumb()
  frmMain.picVis(4).BorderStyle = 0
End Sub

'******************* Form ***********************
Private Sub Form_Unload(Cancel As Integer)
  Call modLibrary.UnloadedForm(Me, frmFilters.vis4)
End Sub

Private Sub Form_Load()
  cmbVisMode.AddItem ("packet length")
  cmbVisMode.AddItem ("rainfall 24:1")
  cmbVisMode.AddItem ("rainfall 8:1")
  cmbVisMode.AddItem ("rainfall 1:1")
  'cmbVisMode.AddItem ("ASCII")
  'cmbVisMode.AddItem ("hex")
  'cmbVisMode.AddItem ("decimal")
  'cmbVisMode.AddItem ("binary")
  cmbVisMode.ListIndex = 2 'set to first item in the list
End Sub

Public Sub ScreenShot(systemTime As String)
  SavePicture picGraph.Image, App.Path & "\" & systemTime & "_binaryrainfall.bmp"
End Sub


Public Sub clear()
  scrollLocation = 0
  picGraph.Cls
  picGraphBack.Cls
  
  thumbScrollLocation = 0
  frmMain.picVis(4).Cls
End Sub


